--- incoming.c.orig
+++ incoming.c
@@ -1854,6 +1854,8 @@
 	for( j = 0 ; j < i->files.count ; j ++ ) {
 		const char *basefilename = i->files.values[j];
 		size_t l = strlen(basefilename);
+		char *fullfilename;
+
 #define C_SUFFIX ".changes"
 #define C_LEN strlen(C_SUFFIX)
 		if( l <= C_LEN ||
@@ -1861,7 +1863,16 @@
 		if( changesfilename != NULL && strcmp(basefilename, changesfilename) != 0 )
 			continue;
 		/* a .changes file, check it */
+		fullfilename = calc_dirconcat(i->directory, i->files.values[j]);
+		if( fullfilename == NULL ) {
+			result = RET_ERROR_OOM;
+			continue;
+		}
+		printf("processing changesfile '%s'\n", fullfilename);
+		fprintf(stderr, "processing changesfile '%s'\n", fullfilename);
 		r = process_changes(database, i, j);
+		printf("changesfile '%s' done\n", fullfilename);
+		fprintf(stderr, "changesfile '%s' done\n", fullfilename);
 		RET_UPDATE(result, r);
 	}
 
